// GUNFIGHTER
// By Banjo
// banjosbbs@hotmail.com
// www.banjosbbs.blogspot.com
// Version 0.6
//
// CREDITS:
// Script by Banjo.
// Opponent images copyright Action Girls (www.actiongirls.com)
// Sound effects copyright Nintendo (from the NES game Wild Gunman)
// Spanking sounds recorded and edited by Banjo.
//
// COPYRIGHT:
// This script, from http://ss.deviatenow.com, is protected by this licence:
// CC BY-NC-ND, see http://creativecommons.org/licenses/by-nc-nd/4.0/
// This copyright refers only to this script itself; it does not include any other included resources (images, music, sounds, etc.) which remain the property of their owners.
//
// SCRIPT RESOURCES
// This contains a list of files included with the script when published to the SexScripts website
/*
 * Resources
 * scripts/Banjo/gunfighter.groovy
 * images/gunfighter/*.jpg
 * images/gunfighter/*.png
 * images/gunfighter/Angel/*.jpg
 * images/gunfighter/Danni/*.jpg
 * images/gunfighter/Kelly/*.jpg
 * images/gunfighter/Mayhem/*.jpg
 * images/gunfighter/Nancy/*.jpg
 * images/gunfighter/Nina/*.jpg
 * images/gunfighter/Sasha/*.jpg
 * sounds/banjo/gunfighter/*.mp3
 * run_gunfighter.bat
 */
//

//Metadata
setInfos(4, "Gunfighter",
	"Quickdraw game",
	"Banjo",
	"v0.6", 0xFFEEEE, "en",
	["game","femaledom","formale","roleplay"]);

//User Settings
def lives = 3
def arcadeShuffle = false
def difficulty = "Normal"
def handicap = 0
def debug = true

//Load Saved Settings
def loadSettings = {
	if(loadBoolean("Banjo.gunfighter.custom")) {
		difficulty = loadString("Banjo.gunfighter.difficulty")
		handicap = loadInteger("Banjo.gunfighter.handicap")
		lives = loadInteger("Banjo.gunfighter.lives")
		arcadeShuffle = loadBoolean("Banjo.gunfighter.arcadeShuffle")
		debug = loadBoolean("Banjo.gunfighter.debug")
	}
}

//System Settings
def opponentsArray = ["Nancy","Danni","Kelly","Nina","Mayhem","Angel","Sasha"]
def quit
def mode
def choiceArray
def choice
def choicePick
def opponentsRemaining
def opponentsDefeated = ["None"]
def opponent
def opponentPick
def opponentName
def opponentOccupation
def opponentHome
def opponentSpeed
def opponentScore
def opponentTauntsReady
def opponentTauntsWin
def opponentTauntsLose
def tauntReady
def tauntWin
def tauntLose
def round
def remaining
def gameover
def won
def score
def wins
//def opponent1
//def opponent2
//def opponent3
//def opponent4
//def opponent5
//def opponent6
//def opponent7

//Common Functions
def showPause = {
	text ->
	show(text)
	showButton("Okay")
}

def showLives = {
	playSound("banjo/gunfighter/scorebeep.mp3")
	show("Chances: "+lives+"")
	wait(2)
}

//Intro
def introLogo = {
	playBackgroundSound(null)
	setImage("gunfighter/titleplain.jpg")
	show("GUNFIGHTER\n\nScript by Banjo\n\nImages copyright ActionGirls.com\nSounds copyright Nintendo")
	playBackgroundSound("banjo/gunfighter/introtune.mp3")
}

def introTextCrawl = {
	def playIntro = true
	def skipIntro
	while(playIntro) {
		setImage("gunfighter/intro_01.jpg")
		playBackgroundSound("banjo/gunfighter/introcrawl.mp3")
		show("In the year 20XX...\n\nThe world has been devastated by the wars waged by men.\n\nDestruction on a massive scale nearly destroyed humanity.")
		skipIntro = showButton("Skip Intro", 11)
		if(skipIntro<11) {
			playIntro = false
		} else {
			setImage("gunfighter/intro_02.jpg")
			show("From the ashes of the old world, a new one has arisen.\n\nSociety has reverted to feudalism. Rebuilding is slow.")
			skipIntro = showButton("Skip Intro", 11)
			if(skipIntro<11) {
				playIntro = false
			} else {
				setImage("gunfighter/intro_03.jpg")
				show("Unlike the one that destroyed itself, the new world is run by women.\n\nEach settlement, small or large, is firmly under female rule.")
				skipIntro = showButton("Skip Intro", 12)
				if(skipIntro<12) {
					playIntro = false
				} else {
					setImage("gunfighter/intro_04.jpg")
					show("So as not to allow the follies of men to bring about ruin ever again, males are now subjugated to second-class citizenry almost everywhere.\n\n"+
						"Kept as slaves for labour, entertainment and breeding, they have no rights.\n\nMost men are now slaves.")
					skipIntro = showButton("Skip Intro", 14)
					if(skipIntro<14) {
						playIntro = false
					} else {
						setImage("gunfighter/intro_05.jpg")
						show("Those few 'free men' who hide in the wastelands beyond the female-ruled citadels and townships live in constant fear of "+
							"Bounty Huntresses searching for fresh slaves to sell at the settlements.")
						skipIntro = showButton("Skip Intro", 12)
						if(skipIntro<12) {
							playIntro = false
						} else {
							setImage("gunfighter/intro_06.jpg")
							show("Among the settlements, a popular sport has arisen: 'Gunfighter'.\n\nInspired by the quick-draw legends of the American Wild West, Gunfighter duels "+
								"can be private affairs to settle disagreements, or professional tournaments with cheering crowds betting on the winners.\n\n"+
								"Armed with weapons that fire paintball-like rounds filled with chemicals that disintergrate clothing and cause no more "+
								"than a painful but temporary stinging sensation, the object is to humiliate rather than harm.")
							skipIntro = showButton("Skip Intro", 16)
							if(skipIntro<16) {
								playIntro = false
							} else {
								setImage("gunfighter/intro_07.jpg")
								show("As befits the new world, these tournaments are usually held between skilled women, with males only forced to take part as a 'joke', expected to lose to their superior female opponents.")
								skipIntro = showButton("Skip Intro", 12)
								if(skipIntro<12) {
									playIntro = false
								} else {
									setImage("gunfighter/intro_08.jpg")
									show("That was, until the day a mysterious male appeared in one such tournament, one who surprised women everywhere with his skill and aim.\n\n"+
										"This man would become know as...\n\nTHE GUNMAN.")
									skipIntro = showButton("Skip Intro", 12)
									if(skipIntro<12) {
										playIntro = false
									} else {
										playIntro = false
									}
								}
							}
						}
					}
				}
			}
		}
	}
	playBackgroundSound(null)
}

//Settings Menu
def settingsMenu = {
	loadSettings()
	def difficultySet = getSelectedValue("Select Difficulty Level\n\n(Currently "+difficulty+")",["Easy", "Normal", "Hard"])
	if(difficultySet==0) {
		show("Difficulty set to Easy.")
		handicap = 0.5
		difficulty = "Easy"
	} else if(difficultySet==1) {
		show("Difficulty set to Normal.")
		handicap = 0
		difficulty = "Normal"
	} else if(difficultySet==2) {
		show("Difficulty set to Hard.")
		handicap = -0.25
		difficulty = "Hard"
	}
	wait(2)
	def livesSet = getSelectedValue("Select number of Chances per game\n\n(Currently "+lives+")",["1","3","6"])
	if(livesSet==0)
		lives = 1
	else if(livesSet==1)
		lives = 3
	else if(livesSet==2)
		lives = 6
	show("Chances set to "+lives+".")
	wait(2)
	arcadeShuffle = getBoolean("Shuffle Arcade Mode opponents?\n\n(currently "+arcadeShuffle+")","True","False")
	show("Arcade Shuffle is "+arcadeShuffle+".")
	wait(2)
	debug = getBoolean("Enable debug mode?\n\n(currently "+debug+")","True","False")	
	show("Debug set to "+debug+".")
	wait(2)
	show("Settings saved.")
	save("Banjo.gunfighter.difficulty",difficulty)
	save("Banjo.gunfighter.handicap",handicap)
	save("Banjo.gunfighter.lives",lives)
	save("Banjo.gunfighter.arcadeShuffle",arcadeShuffle)
	save("Banjo.gunfighter.debug",debug)
	save("Banjo.gunfighter.custom",true)
	wait(2)
}

//Opponent Setup
def setOpponent = {
	if(opponent=="Nancy") {
		opponentName = "Nasty Nancy"
		opponentHome = "Rust Town"
		opponentOccupation = "Gang Leader"
		opponentSpeed = 1.5
		opponentScore = 5
		opponentTauntsReady = ["I'm gonna to shoot ya right in the balls!","Who the fuck are you?"]
		opponentTauntsWin = ["Fucking loser!","I hope that fucking hurt like hell!"]
		opponentTauntsLose = ["Fuck you!"]
	} else if(opponent=="Danni") {
		opponentName = "Danni Dollars"
		opponentHome = "Barterville"
		opponentOccupation = "Pimp"
		opponentSpeed = 1.25
		opponentScore = 10
		opponentTauntsReady = ["Time to put your money where your mouth is!","I wouldn't bet on your chances."]
		opponentTauntsWin = ["And that's the money shot!","I'd buy that for a dollar!"]
		opponentTauntsLose = ["I can't believe you cashed ME out!"]
	} else if(opponent=="Kelly") {
		opponentName = "Kelly Steele"
		opponentHome = "Freshmeat Market"
		opponentOccupation = "Bounty Huntress"
		opponentSpeed = 1
		opponentScore = 15
		opponentTauntsReady = ["I've hunted down tougher men than you.","You'd fetch a fine price at a slave auction."]
		opponentTauntsWin = ["Looks like I'll be taking you in!","I wonder how much your little ass will sell for?"]
		opponentTauntsLose = ["I won't forget this!"]
	} else if(opponent=="Nina") {
		opponentName = "Nina Prime"
		opponentHome = "Temple of Artemis"
		opponentOccupation = "Hand of Artemis"
		opponentSpeed = 1
		opponentScore = 20
		opponentTauntsReady = ["Prepare for defeat, inferior worm!","You dare stand against the superior sex?"]
		opponentTauntsWin = ["Now you see why I'm superior!","On your knees where you belong, scum!"]
		opponentTauntsLose = ["But... but I'm superior..!","How... how can you be that fast?"]
	} else if(opponent=="Mayhem") {
		opponentName = "Major Mayhem"
		opponentHome = "The Iron Citadel"
		opponentOccupation = "Military Officer"
		opponentSpeed = 0.75
		opponentScore = 25
		opponentTauntsReady = ["I'm gonna blow you away, wimp!","Gonna send ou running home to Momma!"]
		opponentTauntsWin = ["Ha ha ha!","Game over, wimp!"]
		opponentTauntsLose = ["You asshole!","This isn't over, wimp!","I'll be back!"]
	} else if(opponent=="Angel") {
		opponentName = "Angel Cortez"
		opponentHome = "The Forge"
		opponentOccupation = "Factory Owner"
		opponentSpeed = 0.75
		opponentScore = 30
		opponentTauntsReady = ["You're going down, pendejo!","You think you're a match for me?!"]
		opponentTauntsWin = ["Hasta la vista, baby!","Adios, mocoso!"]
		opponentTauntsLose = ["Cabron!"]
	} else if(opponent=="Sasha") {
		opponentName = "Sasha Strong"
		opponentHome = "Matriarch City"
		opponentOccupation = "Professional Gunfighter"
		opponentSpeed = 0.5
		opponentScore = 35
		opponentTauntsReady = ["So, you think you can beat me?","This ends now."]
		opponentTauntsWin = ["No contest.","I win.","Pathetic."]
		opponentTauntsLose = ["I... I can't believe it!","But... how?"]
	}
}

def pickOpponentRandom = {
	opponent = opponentsRemaining[getRandom(opponentsRemaining.size)]
	setOpponent()
}

def pickOpponentOrdered = {
	opponent = opponentsRemaining[0]
	setOpponent()
}

def setOpponents = {
	opponentsRemaining = opponentsArray
	remaining = opponentsRemaining.size()
}

def removeOpponent = {
	opponentsRemaining = opponentsRemaining - opponent
	opponentsDefeated = opponentsDefeated + ["<s>"+opponent+"</s>"]
	wins ++
}

def scorePoints = {
	if(arcadeShuffle)
		score = score + (round*5)
	else
		score = score + opponentScore
}

def setRoster = {
//	opponent1 = opponentsRemaining[0]
//	opponent2 = opponentsRemaining[1]
//	opponent3 = opponentsRemaining[2]
//	opponent4 = opponentsRemaining[3]
//	opponent5 = opponentsRemaining[4]
//	opponent6 = opponentsRemaining[5]
//	opponent7 = opponentsRemaining[6]
	opponentsDefeated = opponentsDefeated - ["None"]
}

def showRoster = {
	def opponentsRemainingList = opponentsRemaining.join("\n")
	def opponentsDefeatedList = opponentsDefeated.join("\n")
	show("OPPONENTS:\n"+opponentsDefeatedList+"\n"+opponentsRemainingList)
	showButton("Continue")
}

//Set Taunts
def setTauntReady = {
	tauntReady = opponentTauntsReady[getRandom(opponentTauntsReady.size)]
}

def setTauntWin = {
	tauntWin = opponentTauntsWin[getRandom(opponentTauntsWin.size)]
}

def setTauntLose = {
	tauntLose = opponentTauntsLose[getRandom(opponentTauntsLose.size)]
}

//Gunfight Engine
def roundStart = {
	setImage("gunfighter/"+opponent+"/profile.jpg")
	if(!debug)
		show("Round: "+round+" of "+remaining+"\n\n\n\nVersus: "+opponentName+"\n\n"+
			"Hometown: "+opponentHome+"\n"+
			"Occupation: "+opponentOccupation+"")
	else
		show("Round: "+round+" of "+remaining+"\n\n\n\nVersus: "+opponentName+"\n\n"+
			"Hometown: "+opponentHome+"\n"+
			"Occupation: "+opponentOccupation+"\n"+
			"Speed Rating: "+(opponentSpeed+handicap)+"")
	playSound("banjo/gunfighter/round.mp3")
	wait(2)
}

def gunfight = {
	show("<i>Place your mouse cursor in the box below and stand facing your monitor with your hands by your sides.</i>\n\n\n[&nbsp;&nbsp;]")
	waitWithGauge(6)
	setTauntReady()
	show("'"+tauntReady+"'\n\n\n\n[&nbsp;&nbsp;]")
	setImage("gunfighter/"+opponent+"/approach"+(getRandom(2)+1)+".jpg")
	playSound("banjo/gunfighter/opponent.mp3")
	setImage("gunfighter/"+opponent+"/ready"+(getRandom(2)+1)+".jpg")
	show("...\n\n\n\n[&nbsp;&nbsp;]")
	def drawOpponent = getRandom(9)+1
	playSound("banjo/gunfighter/getready"+drawOpponent+".mp3")
	def drawImage = getRandom(2)+1
	setImage("gunfighter/"+opponent+"/draw"+drawImage+".jpg")
	show("DRAW!\n\n\n\n[&nbsp;&nbsp;]")
	playBackgroundSound("banjo/gunfighter/fire.mp3")
	def fireOpponent = getRandom(2) + opponentSpeed + handicap
	def firePlayer = showButton("FIRE!", fireOpponent)
	show(null)
	if(firePlayer>=fireOpponent) {
		setImage("gunfighter/"+opponent+"/draw"+drawImage+"splat.jpg")
		playSound("banjo/gunfighter/gunsplat.mp3")
		wait(2)
		setImage("gunfighter/"+opponent+"/win"+(getRandom(2)+1)+".jpg")
		setTauntWin()
		show("'"+tauntWin+"'")
		playSound("banjo/gunfighter/lose.mp3")
		wait(4)
		won = false
	} else {
		setImage("gunfighter/splat.png")
		playSound("banjo/gunfighter/gunsplat.mp3")
		wait(2)
		setImage("gunfighter/"+opponent+"/lose"+(getRandom(2)+1)+".jpg")
		setTauntLose()
		show("'"+tauntLose+"'")
		playSound("banjo/gunfighter/win.mp3")
		wait(4)
		won = true
	}
}

//Arcade Mode
def arcadeMode = {
	mode = "arcade"
	setImage("gunfighter/mode_arcade.jpg")
	score = 0
	wins = 0
	round = 1
	setOpponents()
	if(arcadeShuffle)
		pickOpponentRandom()
	else
		pickOpponentOrdered()
	setRoster()
	if(!arcadeShuffle)
		showRoster()
	gameover = false
	while(!gameover) {
		while(round<=remaining && !gameover) {
			roundStart()
			gunfight()
			if(won==true) {
				scorePoints()
				setImage("gunfighter/round_win.jpg")
				show("You won the round!\n\nChances: "+lives+"\nScore: "+score+"")
				playSound("banjo/gunfighter/scorepoints.mp3")
				removeOpponent()
				round ++
				showButton("Next Round")
				if(!arcadeShuffle)
					showRoster()
			} else {
				lives --
				setImage("gunfighter/round_lose.jpg")
				show("You lost the round!\n\nChances: "+lives+"\nScore: "+score+"")
				playSound("banjo/gunfighter/scorebeep.mp3")
				showButton("Try Again")
			}
			if(lives<=0) {
				setImage("gunfighter/game_lose.jpg")
				round = remaining
				show("Game Over!\n\nChances: "+lives+"\nScore: "+score+"")
				playSound("banjo/gunfighter/gameover.mp3")
				showButton("Back to Menu")
				gameover = true
			} else if(round>=remaining) {
				setImage("gunfighter/game_win.jpg")
				show("You Won!\n\nChances: "+lives+"\nScore: "+score+"")
				playSound("banjo/gunfighter/gamewon.mp3")
				showButton("Back to Menu")
				gameover = true
			} else {
				if(arcadeShuffle)
					pickOpponentRandom()
				else
					pickOpponentOrdered()
			}
		}
	}
}

//Story Mode
def storyMode = {
	mode = "story"
	setImage("gunfighter/mode_story.jpg")
	showPause("Sorry!\n\nThis mode is not available yet.")
}

//Main Menu
def mainMenu = {
	choiceArray = ["Arcade Mode","Story Mode","Watch Intro","Settings","Quit"]
	quit = false
	while(!quit) {
		introLogo()
		mode = "menu"
		setImage("gunfighter/titlelogo.jpg")
		choice = getSelectedValue("GUNFIGHTER\n\nScript by Banjo\n\nImages copyright ActionGirls.com\nSounds copyright Nintendo",choiceArray)
		choicePick = choiceArray[choice]
		if(choicePick=="Quit") {
			playBackgroundSound(null)
			show("Exiting...")
			setImage("gunfighter/game_quit.jpg")
			wait(2)
			quit = true
		} else if(choicePick=="Arcade Mode") {
			playBackgroundSound(null)
			arcadeMode()
		} else if(choicePick=="Story Mode") {
			playBackgroundSound(null)
			storyMode()
		} else if(choicePick=="Watch Intro") {
			playBackgroundSound(null)
			introTextCrawl()
			introLogo()
		} else if(choicePick=="Settings") {
			playBackgroundSound(null)
			settingsMenu()
		}
	}
}

//SCRIPT START
show(null)
setImage(null)
loadSettings()
//introLogo()
mainMenu()
show(null)
setImage(null)

//SCRIPT END
